/*
 *   wakearp.exe - force the machines in the local /24 to show in your 'arp -a'
 *   Copyright (C) 2005  Eli Fulkerson
 *
 *   updates and whatnot for 'wakearp.exe' are likely to be found at http://www.elifulkerson.com
 *
 *   Based on the Practical C++ Socket library, available at the time of writing from:
 *   http://cs.ecs.baylor.edu/~donahoo/practical/CSockets/practical/, by Jeff_Donahoo@Baylor.edu
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "PracticalSocket.h"

#define ECHO_MAX_LENGTH 255
#define UDP_DISCARD 9

using namespace std;


int main(int argc, char *argv[]) {

  if ((argc < 2))
  {
    printf("Usage: %s <x.y.z>\n", argv[0]);
	printf("\n");
	printf("Will induce arp resolution for all IP addresses x.y.z.0 - x.y.z.254\n");
	printf("\n");
	printf("This utility lives at:  http://www.elifulkerson.com\n");
    exit(1);
  }


  char servAddress[60];
  strcpy(servAddress, argv[1]);

  char echoString[ECHO_MAX_LENGTH];
  strcpy(echoString, "...just filling my arp table, thank ye...");  // never trust an empty variable.


  int echoStringLen = 0;

  echoStringLen = strlen(echoString);
  
  
  try {
    UDPSocket sock;
  
	char newAddress[60];
	strcpy(newAddress, "");
	
	printf("Trying %s.0 through %s.254.\n", servAddress, servAddress);
	
	for (int i=1; i<254;i++) {
		
		sprintf(newAddress, "%s.%d",servAddress,i);
		sock.sendTo(echoString, echoStringLen, newAddress, UDP_DISCARD);
		// deliberately not checking for a response...
		
	}
	printf("\n");
	printf("Done! Responses from %s.0 to %s.254 should now be in 'arp -a'\n", servAddress, servAddress);
	
  } catch (SocketException &e) {
	printf("%s\n", e.what());
    exit(1);
  }
    
  return 0;
}
